src/br/com/javamagazine/mb/CadastroManagedBean.java
package br.com.javamagazine.mb;

import java.io.IOException;
import java.util.List;
import java.util.Map;

import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpSession;

import br.com.javamagazine.ejb.CadastroEJB;
import br.com.javamagazine.pojo.Livro;

@SessionScoped
@ManagedBean(name = "cadastro")
public class CadastroManagedBean {

	@EJB
	private CadastroEJB cadastro;

	private Livro livro;

	public CadastroManagedBean() {
		this.livro = new Livro();
	}

	public String gravar() {
		cadastro.salvar(livro);
		return "/index.xhtml?faces-redirect=true";
	}

	public String editar() {
		Map<String, String> params = getParams();
		String id = params.get("id");
		if (id != null){
			this.livro = cadastro.buscarPorId(Long.parseLong(id));
		}
		return "/protegida/cadastro-jsf.xhtml?faces-redirect=true";
	}
	
	public String confirmar() {
		Map<String, String> params = getParams();
		String id = params.get("id");
		if (id != null){
			this.livro = cadastro.buscarPorId(Long.parseLong(id));
		}
		return "/protegida/admin/confirmar.xhtml?faces-redirect=true";
	}
	
	public String excluir() {
		cadastro.excluir(livro.getId());
		return "/protegida/admin/admin.xhtml?faces-redirect=true";
	}

	private Map<String, String> getParams() {
		FacesContext fc = FacesContext.getCurrentInstance();
		return fc.getExternalContext().getRequestParameterMap();
	}

	public List<Livro> getLivros() {
		return cadastro.listar();
	}

	public Livro getLivro() {
		return livro;
	}

	public void setLivro(Livro livro) {
		this.livro = livro;
	}
	
	public void logout() throws IOException{
		ExternalContext ctx = FacesContext.getCurrentInstance().getExternalContext();
		HttpSession session = (HttpSession) ctx.getSession(false);
		session.invalidate();
		ctx.redirect(ctx.getRequestContextPath() + "/index.xhtml");
	}
}

WebContent/erro403.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">

<ui:composition template="/templates/template.xhtml">
	<ui:define name="principal">
		 <h3>Ops! Você não tem permissão administrativa.</h3>
		 <br/>
		 <h:form>
		    <h:commandLink onclick="history.go(-1)" value="Voltar" />
		 </h:form>
	</ui:define>
</ui:composition>

</html>

WebContent/erro500.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">

<ui:composition template="/templates/template.xhtml">
	<ui:define name="principal">
		 <h3>Ops! Erro interno do servidor.</h3>
		 <br/>
		 <h:form>
		    <h:commandLink onclick="history.go(-1)" value="Voltar" />
		 </h:form>
	</ui:define>
</ui:composition>

</html>

WebContent/index.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">

<ui:composition template="/templates/template.xhtml">
	<ui:define name="principal">
		<h3>Listagem</h3>
		<h:form>
		    <h:panelGroup rendered="#{empty cadastro.livros}">
		       <h:outputText value="Não há livros cadastrados!" />
		    </h:panelGroup>
			<h:dataTable rendered="#{not empty cadastro.livros}" styleClass="listagem" value="#{cadastro.livros}"
				var="livro" cellspacing="0" rowClasses="row1,row2">
				<h:column>
					<f:facet name="header">
						<h:outputText value="ID" />
					</f:facet>
					<h:outputText value="#{livro.id}" />
				</h:column>
				<h:column>
					<f:facet name="header" sytle="text-align:left">
						<h:outputText value="Título" />
					</f:facet>
					<h:outputText value="#{livro.nome}" />
				</h:column>
			</h:dataTable>
		</h:form>
	</ui:define>
</ui:composition>

</html>

WebContent/invalido.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">

<ui:composition template="/templates/template.xhtml">
	<ui:define name="principal">
		 <h3>Ops! Login ou senha inválidos.</h3>
		 <br/>
		 <h:form>
		    <h:commandLink onclick="history.go(-1)" value="Voltar" />
		 </h:form>
	</ui:define>
</ui:composition>

</html>

WebContent/login.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">

<ui:composition template="/templates/template.xhtml">
	<ui:define name="principal">
		<div style="margin: auto; width: 400px;">
			<h3>Autenticação</h3>
			<form method="post" action="j_security_check">
				<h:panelGrid columns="2">
					<h:outputLabel for="j_username" value="Login" />
					<h:inputText id="j_username" />
					<h:outputLabel for="j_password" value="Senha" />
					<h:inputSecret id="j_password" />
					<h:outputLabel value="" />
					<h:panelGroup style="margin-top: 7px; display: block;">
						<input type="submit" name="submit" value="Entrar" />
						<h:outputLabel value=" ou " />
						<a href="#{request.contextPath}/index.xhtml">Voltar</a>
					</h:panelGroup>
				</h:panelGrid>
			</form>
		</div>
	</ui:define>
</ui:composition>

</html>

WebContent/protegida/admin/admin.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">

<ui:composition template="/templates/template.xhtml">
    <ui:define name="status">(Página de acesso restrito)</ui:define>
	<ui:define name="principal">
	    <h3>Listagem</h3>
		<h:form>
		    <h:panelGroup rendered="#{empty cadastro.livros}">
		       <h:outputText value="Não há livros cadastrados!" />
		    </h:panelGroup>
		    <h:dataTable rendered="#{not empty cadastro.livros}" styleClass="listagem" value="#{cadastro.livros}" var="livro" 
		       cellspacing="0" rowClasses="row1,row2">
				<h:column>
					<f:facet name="header">
						<h:outputText value="ID" />
					</f:facet>
					<h:outputText value="#{livro.id}" />
				</h:column>
				<h:column>
					<f:facet name="header" sytle="text-align:left">
						<h:outputText value="Título" />
					</f:facet>
					<h:outputText value="#{livro.nome}" />
				</h:column>
				<h:column>
					<f:facet name="header">
						<h:outputText value="Ações" />
					</f:facet>
					<h:commandLink action="#{cadastro.editar}" value="Editar">
						<f:param name="id" value="#{livro.id}" />
					</h:commandLink>
					<h:outputText value=" | " />
					<h:commandLink action="#{cadastro.confirmar}" value="Excluir">
						<f:param name="id" value="#{livro.id}" />
					</h:commandLink>
				</h:column>
			</h:dataTable>
		</h:form>
	</ui:define>
</ui:composition>

</html>

WebContent/protegida/admin/confirmar.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">

<ui:composition template="/templates/template.xhtml">
    <ui:define name="status">(Página de acesso restrito)</ui:define>
	<ui:define name="principal">
		<div style="margin: auto;width: 400px;">
			<h3>Confirmar a exclusão?</h3>
			<h:form>			
			    <h:inputHidden id="id" value="#{cadastro.livro.id}"/>
				<h:outputText value="#{cadastro.livro.nome}" /><br/>
				<h:commandButton type="submit" value="Excluir" action="#{cadastro.excluir}" style="margin-top: 7px" />
			</h:form>
		</div>
	</ui:define>
</ui:composition>

</html>

WebContent/protegida/cadastro-jsf.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">

<ui:composition template="/templates/template.xhtml">
    <ui:define name="status">(Página de acesso restrito)</ui:define>
	<ui:define name="principal">
		<div style="margin: auto;width: 400px;">
			<h3>Cadastro</h3>
			<h:form>			
			    <h:inputHidden id="id" value="#{cadastro.livro.id}"/>
				<h:panelGrid columns="2">
					<h:outputLabel value="Título" />
					<h:inputText id="nome" value="#{cadastro.livro.nome}" />
					<h:outputLabel value="" />
					<h:message for="nome" errorClass="errorMessage" />
					<h:outputLabel value="" />
					<h:commandButton type="submit" value="Gravar" action="#{cadastro.gravar}" style="margin-top: 7px" />
				</h:panelGrid>
			</h:form>
		</div>
	</ui:define>
</ui:composition>

</html>

WebContent/protegida/cadastro-rest.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">

<ui:composition template="/templates/template.xhtml">
    <ui:define name="status">(Página de acesso restrito)</ui:define>
	<ui:define name="principal">
		<div style="margin: auto;width: 400px;">
			<h3>Cadastro</h3>
			<form method="post" action="/wepapp/rest/cadastro/salvar/#{cadastro.livro.id}">			
				<h:panelGrid columns="2">
					<h:outputLabel value="Título" />
					<input type="text" name="titulo" value="#{cadastro.livro.nome}" />
					<h:outputLabel value="" />
					<input type="submit" value="Gravar" style="margin-top: 7px"/>
				</h:panelGrid>
			</form>
		</div>
	</ui:define>
</ui:composition>

</html>

WebContent/templates/template.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">

<head>
<title>Apache TomEE</title>
<style type="text/css">
* {
	margin: 0;
}

body {
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 18px;
}

.pagina {
	border: 1px solid #CAD6E0;
	width: 600px;
	min-height: 300px;
	margin: auto;
	margin-top: 15px;
}

h2, h3 {
	color: #454952;
	margin-bottom: 10px !important;
}

.header {
	width: 100%;
	text-align: center;
	background-color: rgb(228, 235, 235);
	font-family: Verdana, Arial, Helvetica, sans-serif;
	padding-top: 5px;
	padding-bottom: 10px;
}

.header h2 {
	font-size: 24px;
	font-weight: bold;
	box-sizing: border-box;
	margin-top: 10px;
}

.header h3 {
	font-weight: normal;
	font-size: 18px;
	margin-bottom: 10px;
}

.status {
	width: 100%;
	text-align: center;
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 18px;
	box-sizing: border-box;
	padding: 5px;
}

.menu {
	width: 100%;
	text-align: center;
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 18px;
	box-sizing: border-box;
	padding: 5px;
}

input[type="button"], input[type="submit"] {
	padding: 3px 10px;
	font-size: 18px;
}

input[type="text"], input[type="password"] {
	font-size: 18px;
	padding: 5px;
	width: 300px;
}

.principal {
	box-sizing: border-box;
	padding: 30px;
}

.principal h2, .principal h3 {
	margin: auto;
	color: #3A5CA7;
}

table {
 width: 100%;
}

table thead {
   background-color: #65829A;
   color: white;
}

table.listagem tr {
	outline: thin solid #EAEAEA;
}

table > thead > tr > th:nth-child(2){
	text-align: left;
}

table td:nth-child(1) {
	text-align:center;
	width: 40px;
}

table td:nth-child(3){
	text-align:center;
	width: 160px;
}

.row1{
 background:#F8F8F8;
}
 
.row2{
 background:#FFFFFF;
}

.errorMessage{
 color: red;
}

</style>
</head>
<body>
	<div class="pagina">
		<div class="header">
			<h2>Livraria com Apache TomEE</h2>
			<h3>
				<ui:insert name="status">(Página de acesso público)</ui:insert>
			</h3>
			<ui:insert name="menu">
				<div class="menu">
				    <h:form>
					    <h:outputLink value="#{request.contextPath}/index.xhtml">Home</h:outputLink>
					    <h:outputText value=" | " />
						<h:outputLink value="#{request.contextPath}/protegida/cadastro-jsf.xhtml">Cadastro JSF</h:outputLink>
						<h:outputText value=" | " />
						<h:outputLink value="#{request.contextPath}/protegida/cadastro-rest.xhtml">Cadastro REST</h:outputLink>
						<h:outputText value=" | " />
						<h:outputLink value="#{request.contextPath}/protegida/admin/admin.xhtml">Administração</h:outputLink>
						<h:panelGroup rendered="#{request.getUserPrincipal() != null}">
							<h:outputText value=" | " />
							<h:commandLink action="#{cadastro.logout}" value="Sair" />
						</h:panelGroup>
					</h:form>
				</div>
			</ui:insert>
		</div>
		<div class="principal">
			<ui:insert name="principal">Conteúdo da página.</ui:insert>
		</div>
	</div>
</body>
</html>